library dis; uses windows;

type
  _TDIS =  record
    // ancestor Protected members
    ClassPtr:pointer;                 	    // +$0
    garbage:integer;                 	    // +$4
    m_dist:integer;//DisType;               // +$8
    m_pfncchaddr:integer;//PFNCCHADDR;      // +$0C
    m_pfncchconst:integer;//PFNCCHCONST;    // +$10
    m_pfncchfixup:integer;//PFNCCHFIXUP;    // +$14
    m_pfncchregrel:pointer;//PFNCCHREGREL;  // +$18
    m_pfncchreg:integer;//PFNCCHREG;        // +$1C
    m_pfndwgetreg:integer;//PFNDWGETREG;    // +$20
    m_pvClient:PAnsiChar;                   // +$24
    m_addr:Int64;                           // +$28
    // private members
	  m_pbCur:Pointer;                  // +$30
	  m_cbMax:Integer;                  // +$34
    m_cb:Integer;                           // +$38
	  m_rgbInstr:Array[0..15] Of Byte;  // +$3C
	  m_popcd:pointer;//POPCD;          // +$4C
	  m_fAddress32:Boolean;             // +$50
	  m_fOperand32:Boolean;             // +$51
	  m_bSegOverride:Byte;              // +$52
	  m_bPrefix:Byte;                   // +$53
	  m_fAddrOverride:Boolean;          // +$54
	  m_fOperOverride:Boolean;          // +$55
    m_ibOp:Integer;                         // +$58
	  m_ibModrm:Integer;                // +$5C
	  m_cbModrm:Integer;                // +$60
	  m_ibImmed:Integer;                // +$64
	  m_trmta:integer;//TRMTA;          // +$68
	  //m_regmaskRd:REGMASK;
	  //m_regmaskWr:REGMASK;
end;
    _PDIS =^_TDIS;

var
  RDIS:_TDIS; 
  PDIS:_PDIS = nil;


{$L dis112}
Function _CbDisassemble(eax,edx:integer;obj:pointer;BufLen:Integer;Buf:PAnsiChar;adr:Int64):Integer; external;

function PdisNew(a:Integer):pointer; Stdcall;
begin
  PDIS := @RDIS;
  FillMemory(PDIS, sizeof(_TDIS),0);
  PDIS.m_dist:=a;
  PDIS.m_pfncchregrel := @_CbDisassemble;
  PDIS.ClassPtr:=PDIS;
  result := PDIS;
end;

exports
   PdisNew name '?PdisNew@DIS@@SGPAV1@W4DIST@1@@Z';

end.